<idea-plugin version="2">
  <name>Google Cloud Tools Core</name>
  <description>Cloud Tools Core</description>
  <version>0.2.8</version>
  <vendor>Google</vendor>
  <id>com.google.gct.core</id>

  <!-- please see http://confluence.jetbrains.net/display/IDEADEV/Build+Number+Ranges for description -->
  <idea-version since-build="107.105"/>

  <depends>com.intellij.modules.platform</depends>
  <depends>com.intellij.modules.lang</depends>
  <depends>com.intellij.modules.vcs</depends>
  <depends>com.intellij.modules.xml</depends>
  <depends>com.intellij.modules.xdebugger</depends>
  <depends>org.jetbrains.plugins.gradle</depends>
  <depends>com.google.gct.login</depends>
  <depends>Git4Idea</depends>

  <application-components>
    <component>
      <implementation-class>com.google.gct.idea.debugger.DebuggerInitializationComponent</implementation-class>
    </component>
  </application-components>

  <project-components>
  </project-components>

  <extensions defaultExtensionNs="org.jetbrains.plugins.gradle">
     <projectResolve implementation="com.google.gct.idea.appengine.gradle.project.AppEngineGradleProjectResolver"/>
  </extensions>

  <extensions defaultExtensionNs="com.intellij">
    <facetType implementation="com.google.gct.idea.appengine.gradle.facet.AppEngineGradleFacetType"/>
    <editorNotificationProvider implementation="com.google.gct.idea.appengine.gradle.notification.AppEngineStatusNotificationProvider" />
    <externalProjectDataService implementation="com.google.gct.idea.appengine.gradle.service.AppEngineGradleProjectDataService" />
    <configurationType implementation="com.google.gct.idea.appengine.run.AppEngineRunConfigurationType"/>
    <stepsBeforeRunProvider implementation="com.google.gct.idea.appengine.run.AppEngineGradleBeforeRunTaskProvider" />

    <applicationService serviceInterface="com.google.gct.idea.stats.UsageTracker"
                        serviceImplementation="com.google.gct.idea.stats.UsageTrackerDummyImpl" />

    <!-- Dom for the App Engine config files -->
    <dom.fileDescription implementation="com.google.gct.idea.appengine.dom.AppEngineWebFileDescription"/>
    <dom.fileDescription implementation="com.google.gct.idea.appengine.dom.WebAppFileDescription"/>

    <xml.schemaProvider implementation="com.google.gct.idea.appengine.sdk.AppEngineWebXmlSchemaProvider"/>

    <implicitUsageProvider implementation="com.google.gct.idea.appengine.validation.EndpointImplicitUsageProvider"/>

    <checkoutProvider implementation="com.google.gct.idea.git.GcpCheckoutProvider"/>
    <vcsPopupProvider implementation="com.google.gct.idea.git.GcpQuickListContentProvider"/>

    <programRunner implementation="com.google.gct.idea.debugger.CloudDebuggerRunner"/>
    <xdebugger.breakpointType implementation="com.google.gct.idea.debugger.CloudLineBreakpointType"/>
    <projectService serviceImplementation="com.google.gct.idea.debugger.CloudDebugProcessStateSerializer"/>

    <localInspection language="JAVA" shortName="ApiName" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="api.name.name" groupKey="inspections.group.name" enabledByDefault="true" level="ERROR"
                     implementationClass="com.google.gct.idea.appengine.validation.ApiNameInspection"/>

    <localInspection language="JAVA" shortName="ApiNamespace" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="api.namespace.name" groupKey="inspections.group.name" enabledByDefault="true" level="ERROR"
                     implementationClass="com.google.gct.idea.appengine.validation.ApiNamespaceInspection"/>

    <localInspection language="JAVA" shortName="ApiParameter" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="api.parameter.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.ApiParameterInspection"/>

    <localInspection language="JAVA" shortName="Constructor" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="constructor.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.ConstructorInspection"/>

    <localInspection language="JAVA" shortName="FullJavaName" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="backend.name.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.FullJavaNameInspection"/>

    <localInspection language="JAVA" shortName="FullMethodName" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="full.method.name.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.FullMethodNameInspection"/>

    <localInspection language="JAVA" shortName="InvalidParameterAnnotations" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="invalid.parameter.annotations.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.InvalidParameterAnnotationsInspection"/>

    <localInspection language="JAVA" shortName="MethodName" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="method.name.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.MethodNameInspection"/>

    <localInspection language="JAVA" shortName="MethodParameterType" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="method.parameter.type.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.MethodParameterTypeInspection"/>

    <localInspection language="JAVA" shortName="MethodReturnType" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="method.return.type.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.MethodReturnTypeInspection"/>

    <localInspection language="JAVA" shortName="NamedResource" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="named.resource.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.NamedResourceInspection"/>

    <localInspection language="JAVA" shortName="ResourceParameter" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="resource.parameter.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.ResourceParameterInspection"/>

    <localInspection language="JAVA" shortName="RestSignature" bundle="messages.EndpointBundle"  hasStaticDescription="true"
                     key="unique.rest.signature.name" groupKey="inspections.group.name" enabledByDefault="true"
                     level="ERROR" implementationClass="com.google.gct.idea.appengine.validation.RestSignatureInspection"/>
  </extensions>

  <extensions defaultExtensionNs="Git4Idea">
    <GitHttpAuthDataProvider implementation="com.google.gct.idea.git.GcpHttpAuthDataProvider" />
  </extensions>

  <actions>
    <action id="AddSnapshotLocation" class="com.google.gct.idea.debugger.actions.ToggleSnapshotLocationAction"/>

    <group id="EditorGutterCloudDebuggerMenu">
      <separator/>
      <reference ref="AddSnapshotLocation"/>
      <add-to-group group-id="EditorGutterPopupMenu" anchor="last"/>
    </group>

    <group id="GoogleCloudTools.BreakpointWatchContextMenu">
      <reference ref="XDebugger.NewWatch"/>
      <reference ref="XDebugger.EditWatch"/>
      <reference ref="XDebugger.CopyWatch"/>
      <reference ref="XDebugger.RemoveWatch"/>
      <reference ref="XDebugger.RemoveAllWatches"/>
    </group>

    <action id="GoogleCloudTools.DeployToAppEngine"
            class="com.google.gct.idea.appengine.deploy.AppEngineUpdateAction"
            text="Deploy Module to App Engine...">
      <add-to-group group-id="BuildMenu" anchor="after" relative-to-action="Android.GenerateSignedApk"/>
    </action>
    <action id="GoogleCloudTools.UploadSourceToGCP"
            class="com.google.gct.idea.git.UploadSourceAction">
      <add-to-group group-id="Vcs.Import"/>
    </action>
  </actions>

</idea-plugin>
